package SketchAggSensor;

/**
 * <p>Title: Aggregation Query in Sensor Network with Sketches</p>
 * <p>Description: This code is for the simulation of sensor network with sketches algorithms. It applies with aggregation queries.</p>
 * <p>Copyright: Computer Science Department, Boston University,Copyright (c) 2003</p>
 * <p>Company: Boston University</p>
 * @author Feifei Li
 * @version 1.0
 */

public class Grouping {

    /** Constructor
        @param groups Array specifying the upper bound on sensor reading for
                      each group.  Lower bound of first group is assumed to be 0.
    */
    public Grouping(int[] groups) {
        this.groups = groups;
    }

    /** Return the group number corresponding to the specified sensor
        reading
    */
    public int getGroup(int reading) {
        for (int i = 0; i < groups.length; i++) {
            if (reading <= groups[i]) return i;
        }
        return -1;
    }

    /** Return the number of groups
     */
    public int numGroups() {
        return groups.length;
    }

    /** groups is a sorted list of sensor readings that deliminate the
        upper bounds of groups e.g.
        groups[0] = 10  -- group 0 is readings 0 .. 10
        groups[1] = 20 -- group 1 is readings 11.20
        ...
    */
    private int groups[];

}
