package SketchAggSensor.agg;

import SketchAggSensor.sensor.Sensor;
import SketchAggSensor.InvalidAggregateException;
import java.util.*;


/**
 * <p>Title: Aggregation Query in Sensor Network with Sketches</p>
 * <p>Description: This code is for the simulation of sensor network with sketches algorithms. It applies with aggregation queries.</p>
 * <p>Copyright: Computer Science Department, Boston University,Copyright (c) 2003</p>
 * <p>Company: Boston University</p>
 * @author Feifei Li
 * @version 1.0
 */

public class SumListAgg implements Aggregator {

  public SumListAgg() {
  }
  public Object combine(Sensor sensor, Object agg) throws InvalidAggregateException {
   int reading = sensor.getReading(sensor.QUERY_FIELD);
   if (!(agg instanceof SumListAggObj)) throw new InvalidAggregateException();
   Integer sensorID = new Integer(sensor.getId());
   Integer value = new Integer(reading);
   ((SumListAggObj)agg).cntMap.put(sensorID,value);
    return agg;
  }
  public Object combine(Object agg1, Object agg2) throws InvalidAggregateException {
    if (!(agg1 instanceof SumListAggObj)) throw new InvalidAggregateException();
    if (!(agg2 instanceof SumListAggObj)) throw new InvalidAggregateException();
    SumListAggObj s1 = (SumListAggObj)agg1;
    SumListAggObj s2 = (SumListAggObj)agg2;
    SumListAggObj newAgg = new SumListAggObj();
    newAgg.cntMap = s1.cntMap;
    Iterator keySetS2 = s2.cntMap.keySet().iterator();
    while(keySetS2.hasNext())
    {
      Integer idNext = (Integer)keySetS2.next();
      newAgg.cntMap.put(idNext,s2.cntMap.get(idNext));
    }
    return newAgg;

  }
  public Object emptyAgg(Sensor s) {
    return new SumListAggObj();
  }
  public int getValue(Object agg) throws InvalidAggregateException {
    if (!(agg instanceof SumListAggObj)) throw new InvalidAggregateException();
    SumListAggObj s1 = (SumListAggObj)agg;
    int sum = 0;
    Iterator keySetS = s1.cntMap.keySet().iterator();
    while(keySetS.hasNext())
    {
      Integer idNext = (Integer)keySetS.next();
      Integer reading = (Integer)s1.cntMap.get(idNext);
      sum+=reading.intValue();
    }
    return sum;
  }

  public Object getValueObj(Object agg) throws InvalidAggregateException {
        return null;
  }
  public int getCount(Object agg) throws InvalidAggregateException {
    if (!(agg instanceof SumListAggObj)) throw new InvalidAggregateException();
    return ((SumListAggObj)agg).cntMap.size();
  }
  public int numBytes(Object agg) throws InvalidAggregateException {
    return INT_BYTES;
  }
  public void divide(Object agg, int divisor) throws InvalidAggregateException {

  }
  public Object cloneAgg(Object agg) throws InvalidAggregateException {
    if (!(agg instanceof SumListAggObj)) throw new InvalidAggregateException();
    SumListAggObj newAgg = new SumListAggObj();
    newAgg.cntMap = ((SumListAggObj)agg).cntMap;
    return newAgg;
  }
  public Object makeGuess() {
    return new SumListAggObj();
  }

  class SumListAggObj {
     public HashMap cntMap = new HashMap();
     public String toString() {
         String s = "" + cntMap.size();
         return s;
    }
   }
}